<?php


class db {

    private bool $log=false;

    public function __construct() {
        $this->mysqli = new \mysqli('localhost', 'root', 'ChelentanO2!', 'reestr') ;
        $this->mysqli->set_charset("utf8") ;
    }

    public function query($sql) {
		
		$args = func_get_args();
		
		$sql = array_shift($args);
		$link = $this->mysqli;
		
		$args = array_map(function ($param) use ($link) {
		    if ($param === null) {
		        return 'NULL';
            }
			return "'".$link->escape_string($param)."'";
		},$args);
		
		$sql = str_replace(array('%','?'), array('%%','%s'), $sql);
		
		array_unshift($args, $sql);
		
		$sql = call_user_func_array('sprintf', $args);

		if ($this->get_log()) {
		    (new self())->query('INSERT INTO log_db (query) VALUES (?)',
                $sql);
        }

		$this->last = $this->mysqli->query($sql);
		if ($this->last === false) throw new \Exception('Database error: '.$this->mysqli->error);

		return $this;		
	}
	
	public function assoc() {
		return $this->last->fetch_assoc();
	}
	
	public function all() {
		$result = array();
		while ($row = $this->last->fetch_assoc()) $result[] = $row;
		return $result;
	}
	
	public function num_rows() {
		return $this->last->num_rows;
	}

    public function get_id() {
        return $this->mysqli->insert_id;
    }

    public function get_affected_rows(): int
    {
        return $this->mysqli->affected_rows;
    }

    public function set_log($log): self
    {
        $this->log = $log;
        return $this;
    }

    public function get_log(): bool
    {
        return $this->log;
    }
}
